#define SRAND 1424948110 
#define DUMMY 1
/*MUTATE: 0 - no mutation*/
#define MUTATE MUT_T_FIXED_LOWEST
#define MUT_OFF 0	//no mutation
#define MUT_T_FIXED 3	//mutate at a fixed time point (T_MUT)
#define MUT_T_FIXED_LOWEST 4	//mutate the lowest cell at a fixed time point (T_MUT)

/*mutations can occur in the following lineage only*/
#define MUT_LINEAGE LIN_SC

/*calculation of width for mutation step*/
#define MUT_STEP FIXED_VALUE_RAND
#define FIXED_VALUE_MIN 5	//specifiy exact values (use min,see below)
#define FIXED_VALUE_MAX 6   //specifiy exact values (use max,see below) 
#define FIXED_VALUE_RAND 7   //specifiy exact values (coin flip min/max)

/*enable the mutant*/
#define MUT_TYPE MUT_CYCLETIME
#define T_MUT 25.0	//time from which mutation events can occur


#define MITOSE_SIZE 0.9 //Groesse, ab der eine Zelle als in der M-Phase gilt
#define MPZ 100 //Maximale Anzahl der Messpunkten
#define MAXMARK 20 //Maximale Anzahl der Markierungen
#define MAX_NEIGHB 17 //Peter: Warum 25?


#define ZEITNORM 12.0	//Ein Zeitschritt entspricht ZEITNORM Stunden, ZEITNORM ist nur in vars.h zu benutzen!
#define deltaR 1.0
#define deltaT 0.0005
#define Tmes 1.0

#define RADIUS_LIMIT 0.25 
#define SEG_LENGTH 0.25


#define VORLAUF1 40.0 //Ausgangpunkt
#define VORLAUF2 0.25 //(3.0/ZEITNORM)
#define EXPS 500

#define TS1 (2.0/ZEITNORM)
#define TS2 2.0 //(24.0/ZEITNORM)

#define PSEUDO 0

#define ZFELDER (18+NMUT*2)	//Matrix Zelle Felder Mutation + Counter
#define POS_X 0
#define POS_Y 1
#define POS_Z 2
#define RADIUS 3
#define VA 4	//V_actual (the actual volume of the cell which depends on its radius and the individual volume overlaps with all neighbouring cells)
//?5
#define VT 6	//V_target (the target volume, i.e. the volume the cell would adopt if it were isolated)
#define UID 7
#define FZ_X 8
#define FZ_Y 9
#define FZ_Z 10
#define LINEAGE 11
#define PROL_STAT 13
#define DELTA 14
#define MITO_T 15	//Zeitpunkt der letzten Mitose - Mutationswahrscheinlichkeit haengt davon ab
#define ANCESTOR 16

#define MUT_OFFSET 17

/*do not forget: set MUT_TYPE*/
//Felder fuer Mutation Data
#define NMUT 5
#define MUT_APC 0
#define MUT_CONTACTINH 1
#define MUT_CYCLETIME 2
#define MUT_SUBSTADH 3
#define MUT_NOTCH 4	

//Geometrie d. Krypte
#define Lflat 2.0
#define Lsys 12.0
#define ZTiefe -30.0
#define Steilheit 0.1	//lambda2
#define lambda1 0.25

//Kategorie 1
#define etaN 0.15
#define etaP etaN
#define etaS 0.35
#define etaS_PAN etaS
#define eta0 0.05 //bringt Ruhe ins System          
#define etaV 50.0 //Energie bei Volumenaenderungen (innere Reibung)


//Kategorie 2
#define WZad 0.2 //0.04*5 //Adhaesionsenergie zw. zwei Zellen
#define Toleranz 0.12
//Kategorie 4
#define Delast 0.0533
#define Kelast (1.333/Delast)

//am Ende
#define ZYKLUS (14.0/ZEITNORM) //Dauer eines Zellzyklus in Stunden
#define KICKPOINT -0.05

#define LENS 0.7

#define SCHNITTDICKE 0.9

#define PanBias -7.5 
#define ABias 4.5
#define SBias -0.0

//Lineage-Identifikatoren
#define LIN_TYPES 5
#define LIN_SC 4
#define LIN_PAN 3
#define LIN_GOBLET 2
#define LIN_ENTERO 1

//Lineage-Regulation
#define dDS (ZTiefe+12.5) //ZKoordinate, an der sich die Zellen differenzieren (von unten)
#define LS  (ZTiefe+5.0)

#ifdef WNT_DOWN_ALL
  #define dDS (2*ZTiefe - LS + ZTiefe)  //dDS-=(LS-ZTiefe) == ZTiefe + 12.5 - LS + ZTiefe;
  #define LS ZTiefe
#endif
#ifdef WNT_DOWN_PART
  #define LS ZTiefe
#endif

#ifdef WNT_HIGH
  #define dDS 10
  #define LS 10
#endif

/*delta by each PC and GC: 1*/
#define BNOTCH 1.0	//this is the default value to enable to notch calculation
#define BNOTCH_TISSUE 1.0
#define BNOTCH_NICHE 2.85

#define PAN_Lifetime 114.0 //(57.0d*24.0/ZEITNORM)	//lifetime of panethcells
#define PAN_APOPTOSE_NO_NEIGH_WITH_NOTCH_RECEPTOR 0.5	//1.0==0.5d*24/ZEITNORM 
#define WASH 0.0

#define RC 0.95

#define Pi 3.141592654
#define V0 (4.0/3.0*Pi)

#define Wprol 10.0 //Anzahl der Schritte, in denen Zellen proliferieren
#define Wdif 0.001 //Apoptoserate pro Zellzyklus

#define CWB 550.0
#define CWB_PAN 3500.0

#define TMAX 661.6

/* defines the range of cell properties 
* first index: type of mutation
* second index: 0 => min, 1 => max, 2=> init
* third index: lineage => 0 (Default), {1,2,3,4} defined lineages
*/
double mut_params[NMUT][3][LIN_TYPES];

void init_mut_params() {
  /* [a][b][c]
   * a: property
   * b: 0==min, 1==max, 2==init
   * c: 0==Default for cells, 1..n == LINEAGES*/

  /*set independent default values*/
  mut_params[MUT_APC][0][0]=1;	/*there is only one definition for APC ON or OFF*/
  mut_params[MUT_APC][1][0]=1;
  mut_params[MUT_APC][2][0]=0;

  mut_params[MUT_CONTACTINH][0][0]=Toleranz-0.06;
  mut_params[MUT_CONTACTINH][1][0]=Toleranz+0.06;
  mut_params[MUT_CONTACTINH][2][0]=Toleranz;

  mut_params[MUT_CYCLETIME][0][0]=ZYKLUS-4/ZEITNORM;
  mut_params[MUT_CYCLETIME][1][0]=ZYKLUS+4/ZEITNORM;
  mut_params[MUT_CYCLETIME][2][0]=ZYKLUS;

  mut_params[MUT_SUBSTADH][0][0]=CWB-200;
  mut_params[MUT_SUBSTADH][1][0]=CWB+200;
  mut_params[MUT_SUBSTADH][2][0]=CWB;

  /*relative values, 1==3 PC or 1 GC neighbour*/
  mut_params[MUT_NOTCH][0][0]=0.5;
  mut_params[MUT_NOTCH][1][0]=1.5;
  mut_params[MUT_NOTCH][2][0]=BNOTCH;

  /*copy defaults for all cell_types*/
  int i,j,k; //i,j,k are already defined
  for (i=0;i<NMUT;++i) {
    printf("NOTE: RANGE for MUTATE %i min: %f max: %f init: %f\n",i,mut_params[i][0][0],mut_params[i][1][0],mut_params[i][2][0]);
    
    for (j=0;j<3;++j) {
      for (k=1;k<LIN_TYPES;++k) {
	mut_params[i][j][k]=mut_params[i][j][0];
      }
    }
  }

  /*specific for Paneth cell*/
  //set cell specific defaults
  mut_params[MUT_SUBSTADH][0][LIN_PAN]=CWB_PAN-0; //replace 0, if necessary
  mut_params[MUT_SUBSTADH][1][LIN_PAN]=CWB_PAN+0;
  mut_params[MUT_SUBSTADH][2][LIN_PAN]=CWB_PAN;
}
